﻿using FlexChart101.Resources;
using C1.Xamarin.Forms.Core;
using System;
using Xamarin.Forms.Xaml;
using C1.Xamarin.Forms.Chart;
using Xamarin.Forms;
using System.Globalization;
using System.Collections.Generic;

namespace FlexChart101
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class GettingStartedSample
    {
        List<SalesExpensesDownloadsEntity> _list;
        public GettingStartedSample()
        {
            InitializeComponent();
            
            Title = AppResources.GettingStartedTitle;

            flexChart.ItemsSource = ChartSampleFactory.CreateEntityList();
            _list = (List<SalesExpensesDownloadsEntity>)flexChart.ItemsSource;
            flexChart.AxisY.LabelLoading += AxisY_LabelLoading;
        }

        private void AxisY_LabelLoading(object sender, AxisLabelLoadingEventArgs e)
        {
            Label label = new Label();
            TimeSpan t = TimeSpan.FromSeconds(_list[e.Index].Expenses);
            DateTime dateTime = DateTime.Now + t;
            label.Text = dateTime.ToShortDateString();
            e.Label = label;
        }
    }
}
